%{?mingw_package_header}

Name:           mingw-spice-gtk
Version:        0.27
Release:        4%{?dist}
Summary:        A GTK+ widget for SPICE clients

License:        LGPLv2+
URL:            http://spice-space.org/page/Spice-Gtk
Source0:        http://www.spice-space.org/download/gtk/spice-gtk-%{version}%{?_version_suffix}.tar.bz2
Patch0001:      0001-session-keep-main-channel-on-reconnect.patch
Patch0002:      0002-channel-factorize-failed-authentication.patch
Patch0003:      0003-channel-do-not-enter-channel-iterate-on-early-error.patch
Patch0004:      0004-channel-introduce-SPICE_CHANNEL_STATE_RECONNECTING.patch
Patch0005:      0005-channel-throw-auth-error-when-coroutine-ends.patch
Patch0006:      0006-channel-clear-channel-error-after-auth-error.patch
Patch0007:      0007-usbredir-prevent-crash-when-calling-without-host.patch
Patch0008:      0008-spice-common-fix-build-with-mingw.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch: noarch

BuildRequires: mingw32-filesystem >= 95
BuildRequires: mingw64-filesystem >= 95
BuildRequires: mingw32-gcc
BuildRequires: mingw64-gcc
BuildRequires: mingw32-binutils
BuildRequires: mingw64-binutils
BuildRequires: glib2-devel

BuildRequires: mingw32-gtk2 >= 2.14
BuildRequires: mingw64-gtk2 >= 2.14
BuildRequires: mingw32-gtk3 >= 2.91.3
BuildRequires: mingw64-gtk3 >= 2.91.3
BuildRequires: mingw32-pixman
BuildRequires: mingw64-pixman
BuildRequires: mingw32-openssl
BuildRequires: mingw64-openssl
BuildRequires: mingw32-libjpeg-turbo
BuildRequires: mingw64-libjpeg-turbo
BuildRequires: mingw32-celt051
BuildRequires: mingw64-celt051
BuildRequires: mingw32-zlib
BuildRequires: mingw64-zlib
BuildRequires: mingw32-gstreamer1
BuildRequires: mingw64-gstreamer1
BuildRequires: mingw32-gstreamer1-plugins-base
BuildRequires: mingw64-gstreamer1-plugins-base
BuildRequires: mingw32-gstreamer1-plugins-good
BuildRequires: mingw64-gstreamer1-plugins-good
BuildRequires: mingw32-gstreamer1-plugins-bad
BuildRequires: mingw64-gstreamer1-plugins-bad
BuildRequires: mingw32-opus
BuildRequires: mingw64-opus
# Hack because of bz #613466
BuildRequires: intltool
BuildRequires: libtool

%description
Client libraries for SPICE desktop servers.


# Mingw32
%package -n mingw32-spice-gtk
Summary: %{summary}
Requires: mingw32-spice-glib = %{version}-%{release}
Requires: mingw32-gtk2
Requires: pkgconfig

%description -n mingw32-spice-gtk
Gtk+2 client libraries for SPICE desktop servers.

%package -n mingw32-spice-gtk3
Summary: %{summary}
Requires: mingw32-spice-glib = %{version}-%{release}
Requires: mingw32-gtk3
Requires: pkgconfig

%description -n mingw32-spice-gtk3
Gtk+3 client libraries for SPICE desktop servers.

%package -n mingw32-spice-glib
Summary: GLib-based library to connect to SPICE servers
Requires: pkgconfig
Requires: mingw32-glib2
Requires: mingw32-spice-protocol

%description -n mingw32-spice-glib
A SPICE client library using GLib2.

%package -n mingw32-spice-gtk-static
Summary: %{summary}
Requires: mingw32-spice-gtk = %{version}-%{release}

%description -n mingw32-spice-gtk-static
Gtk+ client static libraries for SPICE desktop servers.

# Mingw64
%package -n mingw64-spice-gtk
Summary: %{summary}
Requires: mingw64-spice-glib = %{version}-%{release}
Requires: mingw64-gtk2
Requires: pkgconfig

%description -n mingw64-spice-gtk
Gtk+2 client libraries for SPICE desktop servers.

%package -n mingw64-spice-gtk3
Summary: %{summary}
Requires: mingw64-spice-glib = %{version}-%{release}
Requires: mingw64-gtk3
Requires: pkgconfig

%description -n mingw64-spice-gtk3
Gtk+3 client libraries for SPICE desktop servers.

%package -n mingw64-spice-glib
Summary: GLib-based library to connect to SPICE servers
Requires: pkgconfig
Requires: mingw64-glib2
Requires: mingw64-spice-protocol

%description -n mingw64-spice-glib
A SPICE client library using GLib2.

%package -n mingw64-spice-gtk-static
Summary: %{summary}
Requires: mingw64-spice-gtk = %{version}-%{release}

%description -n mingw64-spice-gtk-static
Gtk+ client static libraries for SPICE desktop servers.

%{?mingw_debug_package}


%prep
%setup -q -n spice-gtk-%{version}%{?_version_suffix} -c
pushd spice-gtk-%{version}%{?_version_suffix}
%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
popd

if [ -n '%{?_version_suffix}' ]; then
  mv spice-gtk-%{version}%{?_version_suffix} spice-gtk-%{version}
fi

cp -a spice-gtk-%{version} spice-gtk3-%{version}

%build
pushd spice-gtk-%{version}
%mingw_configure                                \
    --without-sasl                              \
    --with-audio=gstreamer1                     \
    --with-coroutine=winfiber                   \
    --disable-smartcard                         \
    --without-python                            \
    --disable-usbredir                          \
    --disable-gtk-doc                           \
    --disable-werror                            \
    --enable-static                             \
    --enable-shared                             \
    --with-gtk=2.0

%mingw_make %{?_smp_mflags}
popd

pushd spice-gtk3-%{version}
%mingw_configure                                \
    --without-sasl                              \
    --with-audio=gstreamer1                     \
    --with-coroutine=winfiber                   \
    --disable-smartcard                         \
    --without-python                            \
    --disable-usbredir                          \
    --disable-gtk-doc                           \
    --disable-werror                            \
    --enable-static                             \
    --enable-shared                             \
    --with-gtk=3.0

%mingw_make %{?_smp_mflags}
popd

%install
rm -rf $RPM_BUILD_ROOT

pushd spice-gtk-%{version}
%mingw_make install "DESTDIR=$RPM_BUILD_ROOT"
popd

pushd spice-gtk3-%{version}
%mingw_make install "DESTDIR=$RPM_BUILD_ROOT"
popd

# Libtool files don't need to be bundled
find $RPM_BUILD_ROOT -name "*.la" -delete
# man pages don't need to be bundled
find $RPM_BUILD_ROOT -name "*.1" -delete

%mingw_find_lang spice-gtk

%clean
rm -rf $RPM_BUILD_ROOT

# Mingw32
%files -n mingw32-spice-glib -f spice-gtk.lang
%defattr(-,root,root)
%doc spice-gtk-%{version}/AUTHORS
%doc spice-gtk-%{version}/ChangeLog
%doc spice-gtk-%{version}/COPYING
%doc spice-gtk-%{version}/README
%doc spice-gtk-%{version}/NEWS
%{mingw32_bindir}/libspice-client-glib-2.0-8.dll
%{mingw32_bindir}/libspice-controller-0.dll
%{mingw32_bindir}/spicy-screenshot.exe
%{mingw32_bindir}/spicy-stats.exe
%{mingw32_libdir}/libspice-client-glib-2.0.dll.a
%{mingw32_libdir}/libspice-controller.dll.a
%{mingw32_libdir}/pkgconfig/spice-client-glib-2.0.pc
%{mingw32_libdir}/pkgconfig/spice-controller.pc
%{mingw32_includedir}/spice-client-glib-2.0
%{mingw32_includedir}/spice-controller
%{mingw32_datadir}/vala/vapi

%files -n mingw32-spice-gtk
%defattr(-,root,root)
%{mingw32_bindir}/libspice-client-gtk-2.0-4.dll
%{mingw32_libdir}/libspice-client-gtk-2.0.dll.a
%{mingw32_libdir}/pkgconfig/spice-client-gtk-2.0.pc
%{mingw32_includedir}/spice-client-gtk-2.0

%files -n mingw32-spice-gtk3
%defattr(-,root,root)
%{mingw32_bindir}/libspice-client-gtk-3.0-4.dll
%{mingw32_bindir}/spicy.exe
%{mingw32_libdir}/libspice-client-gtk-3.0.dll.a
%{mingw32_libdir}/pkgconfig/spice-client-gtk-3.0.pc
%{mingw32_includedir}/spice-client-gtk-3.0

%files -n mingw32-spice-gtk-static
%defattr(-,root,root)
%{mingw32_libdir}/libspice-client-glib-2.0.a
%{mingw32_libdir}/libspice-controller.a
%{mingw32_libdir}/libspice-client-gtk-2.0.a
%{mingw32_libdir}/libspice-client-gtk-3.0.a

# Mingw64
%files -n mingw64-spice-glib -f spice-gtk.lang
%defattr(-,root,root)
%doc spice-gtk-%{version}/AUTHORS
%doc spice-gtk-%{version}/ChangeLog
%doc spice-gtk-%{version}/COPYING
%doc spice-gtk-%{version}/README
%doc spice-gtk-%{version}/NEWS
%{mingw64_bindir}/libspice-client-glib-2.0-8.dll
%{mingw64_bindir}/libspice-controller-0.dll
%{mingw64_bindir}/spicy-screenshot.exe
%{mingw64_bindir}/spicy-stats.exe
%{mingw64_libdir}/libspice-client-glib-2.0.dll.a
%{mingw64_libdir}/libspice-controller.dll.a
%{mingw64_libdir}/pkgconfig/spice-client-glib-2.0.pc
%{mingw64_libdir}/pkgconfig/spice-controller.pc
%{mingw64_includedir}/spice-client-glib-2.0
%{mingw64_includedir}/spice-controller
%{mingw64_datadir}/vala/vapi

%files -n mingw64-spice-gtk
%defattr(-,root,root)
%{mingw64_bindir}/libspice-client-gtk-2.0-4.dll
%{mingw64_libdir}/libspice-client-gtk-2.0.dll.a
%{mingw64_libdir}/pkgconfig/spice-client-gtk-2.0.pc
%{mingw64_includedir}/spice-client-gtk-2.0

%files -n mingw64-spice-gtk3
%defattr(-,root,root)
%{mingw64_bindir}/libspice-client-gtk-3.0-4.dll
%{mingw64_bindir}/spicy.exe
%{mingw64_libdir}/libspice-client-gtk-3.0.dll.a
%{mingw64_libdir}/pkgconfig/spice-client-gtk-3.0.pc
%{mingw64_includedir}/spice-client-gtk-3.0

%files -n mingw64-spice-gtk-static
%defattr(-,root,root)
%{mingw64_libdir}/libspice-client-glib-2.0.a
%{mingw64_libdir}/libspice-controller.a
%{mingw64_libdir}/libspice-client-gtk-2.0.a
%{mingw64_libdir}/libspice-client-gtk-3.0.a

%changelog
* Tue Jan  6 2015 Fabiano Fidêncio <fidencio@redhat.com> 0.27.4
- Drop gstreamer-0.10 in favour to gstreamer-1.0

* Mon Dec 22 2014 Marc-André Lureau <marcandre.lureau@redhat.com> 0.27-3
- Fix usbredir crash on disconnection.

* Tue Dec 16 2014 Marc-André Lureau <marcandre.lureau@redhat.com> 0.27-2
- Fix authentication error handling regression.

* Thu Dec 11 2014 Marc-André Lureau <marcandre.lureau@redhat.com> 0.27-1
- Update to spice-gtk 0.27

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.23-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Mon Feb 10 2014 Marc-André Lureau <marcandre.lureau@redhat.com> 0.23-1
- Update to spice-gtk 0.23

* Wed Dec 18 2013 Marc-André Lureau <marcandre.lureau@redhat.com> 0.22-1
- Update to spice-gtk 0.22

* Wed Sep 18 2013 Marc-André Lureau <marcandre.lureau@redhat.com> 0.21-1
- Update to spice-gtk 0.21

* Thu Aug 01 2013 Christophe Fergeau <cfergeau@redhat.com> 0.20-1
- Update to spice-gtk 0.20

* Sun Jun 16 2013 Erik van Pienbroek <epienbro@fedoraproject.org> - 0.19-3
- Rebuild to resolve InterlockedCompareExchange regression in mingw32 libraries

* Sat Jun 15 2013 Erik van Pienbroek <epienbro@fedoraproject.org> - 0.19-2
- Rebuild to resolve InterlockedCompareExchange regression in mingw32 libraries

* Thu Apr 11 2013 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.19-1
- Update to spice-gtk 0.19

* Wed Feb 13 2013 Christophe Fergeau <cfergeau@redhat.com> - 0.18-1
- Update to spice-gtk 0.18

* Wed Feb  6 2013 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.17-1
- Update to spice-gtk 0.17

* Thu Jan 24 2013 Christophe Fergeau <cfergeau@redhat.com> - 0.16-2
- Add missing Requires (spice-protocol is required by
  spice-client-glib-2.0.pc)

* Tue Jan 22 2013 Christophe Fergeau <cfergeau@redhat.com> - 0.16-1
- Update to spice-gtk 0.16

* Fri Dec 21 2012 Christophe Fergeau <cfergeau@redhat.com> - 0.15-2
- Update to the 0.15 release

* Fri Jul 20 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.12-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Fri May 11 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.12-2
- Remove spice-protocol dependency

* Wed May  2 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.12-1
- Initial mingw64 packaging
